> ## Documentation Index
> Fetch the complete documentation index at: https://docs.nebius.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Update

> Updates the PostgreSQL cluster.



## OpenAPI

````yaml https://api.nebius.cloud/openapi.json patch /msp/postgresql/v1alpha1/clusters
openapi: 3.0.3
info:
  title: Nebius API
  version: version not set
servers:
  - url: https://api.nebius.cloud
security:
  - bearerAuth: []
tags:
  - name: nebius.ai.v1.EndpointService
  - name: nebius.ai.v1.JobService
  - name: nebius.applications.v1alpha1.K8sReleaseService
  - name: nebius.audit.v2.AuditEventExportService
  - name: nebius.audit.v2.AuditEventService
  - name: nebius.billing.v1.CalculatorService
  - name: nebius.billing.v1alpha1.CalculatorService
  - name: nebius.billing.v1alpha1.OneTimeExportService
  - name: nebius.capacity.v1.CapacityAllowanceService
  - name: nebius.capacity.v1.CapacityBlockGroupService
  - name: nebius.capacity.v1.CapacityIntervalService
  - name: nebius.capacity.v1.ResourceAdviceService
  - name: nebius.compute.v1.DiskService
  - name: nebius.compute.v1.DiskSnapshotService
  - name: nebius.compute.v1.FilesystemService
  - name: nebius.compute.v1.GpuClusterService
  - name: nebius.compute.v1.ImageService
  - name: nebius.compute.v1.InstanceService
  - name: nebius.compute.v1.MaintenanceService
  - name: nebius.compute.v1.NVLInstanceGroupService
  - name: nebius.compute.v1.NodeService
  - name: nebius.compute.v1.PlatformService
  - name: nebius.dns.v1.RecordService
  - name: nebius.dns.v1.ZoneService
  - name: nebius.iam.v1.AccessKeyService
  - name: nebius.iam.v1.AccessPermitService
  - name: nebius.iam.v1.AuthPublicKeyService
  - name: nebius.iam.v1.FederatedCredentialsService
  - name: nebius.iam.v1.FederationCertificateService
  - name: nebius.iam.v1.FederationService
  - name: nebius.iam.v1.GroupMembershipService
  - name: nebius.iam.v1.GroupService
  - name: nebius.iam.v1.InvitationService
  - name: nebius.iam.v1.ProfileService
  - name: nebius.iam.v1.ProjectService
  - name: nebius.iam.v1.ServiceAccountService
  - name: nebius.iam.v1.SessionManagementService
  - name: nebius.iam.v1.StaticKeyService
  - name: nebius.iam.v1.TenantService
  - name: nebius.iam.v1.TenantUserAccountService
  - name: nebius.iam.v1.TenantUserAccountWithAttributesService
  - name: nebius.iam.v2.AccessKeyService
  - name: nebius.iam.v2.ProjectService
  - name: nebius.iam.v2.TenantService
  - name: nebius.kms.v1.AsymmetricCryptoService
  - name: nebius.kms.v1.AsymmetricKeyService
  - name: nebius.kms.v1.SymmetricCryptoService
  - name: nebius.kms.v1.SymmetricKeyService
  - name: nebius.logging.agentmanager.v1.VersionService
  - name: nebius.logging.v1.LogExportService
  - name: nebius.maintenance.v1alpha1.MaintenanceService
  - name: nebius.mk8s.v1.ClusterService
  - name: nebius.mk8s.v1.NodeGroupService
  - name: nebius.mk8s.v1alpha1.ClusterService
  - name: nebius.mk8s.v1alpha1.NodeGroupService
  - name: nebius.msp.mlflow.v1alpha1.ClusterService
  - name: nebius.msp.postgresql.v1alpha1.BackupService
  - name: nebius.msp.postgresql.v1alpha1.ClusterService
  - name: nebius.mysterybox.v1.PayloadService
  - name: nebius.mysterybox.v1.SecretService
  - name: nebius.mysterybox.v1.SecretVersionService
  - name: nebius.quotas.v1.QuotaAllowanceService
  - name: nebius.registry.v1.ArtifactService
  - name: nebius.registry.v1.RegistryService
  - name: nebius.storage.v1.BucketService
  - name: nebius.storage.v1.TransferService
  - name: nebius.storage.v1alpha1.TransferService
  - name: nebius.tunnel.v1.TunnelService
  - name: nebius.vpc.v1.AllocationService
  - name: nebius.vpc.v1.NetworkService
  - name: nebius.vpc.v1.PoolService
  - name: nebius.vpc.v1.RouteService
  - name: nebius.vpc.v1.RouteTableService
  - name: nebius.vpc.v1.SecurityGroupService
  - name: nebius.vpc.v1.SecurityRuleService
  - name: nebius.vpc.v1.SubnetService
  - name: nebius.vpc.v1.TargetGroupService
  - name: nebius.vpc.v1alpha1.AllocationService
  - name: nebius.vpc.v1alpha1.NetworkService
  - name: nebius.vpc.v1alpha1.PoolService
  - name: nebius.vpc.v1alpha1.ScopeService
  - name: nebius.vpc.v1alpha1.SubnetService
paths:
  /msp/postgresql/v1alpha1/clusters:
    patch:
      tags:
        - nebius.msp.postgresql.v1alpha1.ClusterService
      summary: Update
      description: Updates the PostgreSQL cluster.
      operationId: ClusterService_Update
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/mspPostgresqlV1alpha1UpdateClusterRequest'
        required: true
        x-originalParamName: body
      responses:
        '200':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/commonV1alpha1Operation'
          description: A successful response.
components:
  schemas:
    mspPostgresqlV1alpha1UpdateClusterRequest:
      properties:
        metadata:
          $ref: '#/components/schemas/commonV1ResourceMetadata'
        spec:
          $ref: '#/components/schemas/mspPostgresqlV1alpha1ClusterSpec'
      required:
        - metadata
      type: object
    commonV1alpha1Operation:
      properties:
        createdAt:
          description: Creation timestamp.
          format: date-time
          type: string
        createdBy:
          description: ID of the user or service account who initiated the operation.
          type: string
        description:
          description: Human readable description of the operation. 0-256 characters long.
          type: string
        finishedAt:
          description: The time when the operation finished.
          format: date-time
          type: string
        id:
          description: ID of the operation.
          type: string
        progressData:
          $ref: '#/components/schemas/protobufAny'
        request:
          $ref: '#/components/schemas/protobufAny'
        requestHeaders:
          additionalProperties:
            $ref: '#/components/schemas/OperationRequest_header'
          title: >-
            The request headers that are essential for the request that
            generated the operation.

            For instance, `x-resetmask`. Without these headers the request might
            have been processed

            differently if repeated.

            All the header names *must* be converted to lower case.

            Validator is based on:

            https://httpwg.org/specs/rfc9110.html#considerations.for.new.field.names
          type: object
        resource:
          $ref: '#/components/schemas/protobufAny'
        resourceId:
          description: >-
            ID of the resource that this operation creates, updates, deletes or
            otherwise changes.


            If the operation affects multiple resources or does not affect any
            API resources at all

            (e.g. a routine maintenance operation visible to the user), the
            [resource_id] must be empty.
          type: string
        status:
          $ref: '#/components/schemas/googleRpcStatus'
      type: object
    commonV1ResourceMetadata:
      description: Common resource metadata.
      properties:
        createdAt:
          description: Timestamp indicating when the resource was created.
          format: date-time
          readOnly: true
          type: string
        id:
          description: Identifier for the resource, unique for its resource type.
          type: string
        labels:
          additionalProperties:
            type: string
          description: Labels associated with the resource.
          type: object
        name:
          description: Human readable name for the resource.
          type: string
        parentId:
          description: Identifier of the parent resource to which the resource belongs.
          type: string
        resourceVersion:
          description: >-
            Version of the resource for safe concurrent modifications and
            consistent reads.

            Positive and monotonically increases on each resource spec change
            (but *not* on each change of the

            resource's container(s) or status).

            Service allows zero value or current.
          format: int64
          type: string
        updatedAt:
          description: Timestamp indicating when the resource was last updated.
          format: date-time
          readOnly: true
          type: string
      required:
        - parentId
      type: object
    mspPostgresqlV1alpha1ClusterSpec:
      properties:
        backup:
          $ref: '#/components/schemas/v1alpha1BackupSpec'
        bootstrap:
          $ref: '#/components/schemas/v1alpha1BootstrapSpec'
        config:
          $ref: '#/components/schemas/v1alpha1ConfigSpec'
        description:
          description: Description of the PostgreSQL cluster.
          type: string
        networkId:
          description: Network ID in which the cluster is created.
          type: string
      required:
        - networkId
        - config
        - bootstrap
      type: object
    protobufAny:
      additionalProperties: {}
      description: >-
        `Any` contains an arbitrary serialized protocol buffer message along
        with a

        URL that describes the type of the serialized message
      properties:
        '@type':
          description: >-
            A URL/resource name that uniquely identifies the type of the
            serialized

            protocol buffer message. This string must contain at least

            one "/" character. The last segment of the URL's path must represent

            the fully qualified name of the type (as in

            `path/google.protobuf.Duration`). The name should be in a canonical
            form

            (e.g., leading "." is not accepted).


            In practice, teams usually precompile into the binary all types that
            they

            expect it to use in the context of Any. However, for URLs which use
            the

            scheme `http`, `https`, or no scheme, one can optionally set up a
            type

            server that maps type URLs to message definitions as follows:


            * If no scheme is provided, `https` is assumed.

            * An HTTP GET on the URL must yield a [google.protobuf.Type][]
              value in binary format, or produce an error.
            * Applications are allowed to cache lookup results based on the
              URL, or have them precompiled into a binary to avoid any
              lookup. Therefore, binary compatibility needs to be preserved
              on changes to types. (Use versioned type names to manage
              breaking changes.)

            Note: this functionality is not currently available in the official

            protobuf release, and it is not used for type URLs beginning with

            type.googleapis.com. As of May 2023, there are no widely used type
            server

            implementations and no plans to implement one.


            Schemes other than `http`, `https` (or the empty scheme) might be

            used with implementation specific semantics.
          type: string
      type: object
    OperationRequest_header:
      properties:
        values:
          items:
            type: string
          title: The values of a particular header from a request
          type: array
      title: >-
        Request header is a container for all the values of a particular header
        of a request

        as there is no such thing as map<string, repeated string>
      type: object
    googleRpcStatus:
      description: >-
        The `Status` type defines a logical error model that is suitable for

        different programming environments, including REST APIs and RPC APIs. It
        is

        used by [gRPC](https://github.com/grpc). Each `Status` message contains

        three pieces of data: error code, error message, and error details.


        You can find out more about this error model and how to work with it in
        the

        [API Design Guide](https://cloud.google.com/apis/design/errors).
      properties:
        code:
          description: |-
            The status code, which should be an enum value of
            [google.rpc.Code][google.rpc.Code].
          format: int32
          type: integer
        details:
          description: >-
            A list of messages that carry the error details.  There is a common
            set of

            message types for APIs to use.
          items:
            $ref: '#/components/schemas/protobufAny'
          type: array
        message:
          description: >-
            A developer-facing error message, which should be in English. Any

            user-facing error message should be localized and sent in the

            [google.rpc.Status.details][google.rpc.Status.details] field, or
            localized

            by the client.
          type: string
      type: object
    v1alpha1BackupSpec:
      properties:
        backupWindowStart:
          title: Backup window start in "HH:MM:SS" format (UTC Time)
          type: string
        retentionPolicy:
          title: Retention policy to be used for backups and WALs (i.e. '7d')
          type: string
      type: object
    v1alpha1BootstrapSpec:
      properties:
        dbName:
          description: Name of the PostgreSQL database. 1-63 characters long.
          type: string
        userName:
          description: Name of the bootstrap PostgreSQL user.
          type: string
        userPassword:
          description: Password of the bootstrap PostgreSQL user.
          type: string
      required:
        - userName
        - dbName
      type: object
    v1alpha1ConfigSpec:
      properties:
        poolerConfig:
          $ref: '#/components/schemas/v1alpha1ConnectionPoolerConfig'
        postgresqlConfig16:
          $ref: '#/components/schemas/configPostgresqlConfig16'
        publicAccess:
          description: >-
            Either make cluster public accessible or accessible only via private
            VPC.
          type: boolean
        template:
          $ref: '#/components/schemas/v1alpha1TemplateSpec'
        version:
          title: |-
            Version of PostgreSQL used in the cluster.
            Possible values: `16`
          type: string
      required:
        - version
        - template
      type: object
    v1alpha1ConnectionPoolerConfig:
      properties:
        maxPoolSize:
          description: >-
            Maximum number of connections in the pool for a single user/database
            pair.
          format: int64
          type: string
        poolingMode:
          $ref: '#/components/schemas/ConnectionPoolerConfigPoolingMode'
      type: object
    configPostgresqlConfig16:
      properties:
        autovacuumAnalyzeScaleFactor:
          format: double
          type: number
        autovacuumNaptime:
          description: in seconds.
          format: int64
          type: string
        autovacuumVacuumCostDelay:
          description: in milliseconds.
          format: int64
          type: string
        autovacuumVacuumCostLimit:
          format: int64
          type: string
        autovacuumVacuumScaleFactor:
          format: double
          type: number
        autovacuumWorkMem:
          description: in kilobytes.
          format: int64
          type: string
        defaultTransactionReadOnly:
          type: boolean
        idleInTransactionSessionTimeout:
          description: in milliseconds.
          format: int64
          type: string
        maxConnections:
          format: int64
          type: string
        searchPath:
          type: string
        sharedBuffers:
          description: in kilobytes.
          format: int64
          type: string
        statementTimeout:
          description: in milliseconds.
          format: int64
          type: string
      type: object
    v1alpha1TemplateSpec:
      properties:
        disk:
          $ref: '#/components/schemas/v1alpha1ResourceDiskSpec'
        hosts:
          $ref: '#/components/schemas/resourceHostSpec'
        resources:
          $ref: '#/components/schemas/v1alpha1ResourceResourcesSpec'
      required:
        - resources
        - hosts
        - disk
      type: object
    ConnectionPoolerConfigPoolingMode:
      default: POOLING_MODE_UNSPECIFIED
      description: |2-
         - SESSION: Session pooling mode.
         - TRANSACTION: Transaction pooling mode.
      enum:
        - POOLING_MODE_UNSPECIFIED
        - SESSION
        - TRANSACTION
      type: string
    v1alpha1ResourceDiskSpec:
      properties:
        sizeGibibytes:
          format: int64
          type: string
        type:
          type: string
      required:
        - type
        - sizeGibibytes
      type: object
    resourceHostSpec:
      properties:
        count:
          format: int64
          type: string
      required:
        - count
      type: object
    v1alpha1ResourceResourcesSpec:
      properties:
        platform:
          type: string
        preset:
          type: string
      required:
        - platform
        - preset
      type: object
  securitySchemes:
    bearerAuth:
      description: The Authorization header expects a Bearer token.
      scheme: bearer
      type: http

````